﻿Public Class Form1

    Private Sub bttnEllipses_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnEllipses.Click
        Dim G As Graphics
        G = PictureBox1.CreateGraphics '' use this statement for permanent drawing: G = GetGraphicsObject()
        G.Clear(PictureBox1.BackColor)
        G.SmoothingMode = Drawing.Drawing2D.SmoothingMode.AntiAlias
        G.FillRectangle(Brushes.Silver, ClientRectangle)
        Dim R1, R2 As Rectangle
        R1 = New Rectangle(10, 10, 160, 320)
        R2 = New Rectangle(200, 85, 320, 160)

        G.DrawEllipse(New Pen(Color.Black, 3), R1)
        G.DrawRectangle(Pens.Black, R1)
        G.DrawEllipse(New Pen(Color.Black, 3), R2)
        G.DrawRectangle(Pens.Red, R2)
    End Sub

    Private Sub bttnCurves_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnCurves.Click
        Dim G As Graphics
        G = PictureBox1.CreateGraphics '' use this statement for permanent drawing: G = GetGraphicsObject()
        G.Clear(PictureBox1.BackColor)
        G.FillRectangle(Brushes.Silver, ClientRectangle)
        G.SmoothingMode = Drawing.Drawing2D.SmoothingMode.HighQuality
        Dim points() As Point = {New Point(20, 50), New Point(220, 190), _
                                 New Point(330, 80), New Point(450, 280)}
        G.DrawCurve(Pens.Blue, points, 0.1)
        G.DrawCurve(Pens.Red, points, 0.5)
        G.DrawCurve(Pens.Green, points, 1)
        G.DrawCurve(Pens.Black, points, 2)
    End Sub

    Private Sub bttnBezier_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnBezier.Click
        Dim G As Graphics
        G = PictureBox1.CreateGraphics '' use this statement for permanent drawing: G = GetGraphicsObject()
        G.Clear(PictureBox1.BackColor)
        G.SmoothingMode = Drawing.Drawing2D.SmoothingMode.AntiAlias
        G.FillRectangle(Brushes.Silver, ClientRectangle)
        Dim P1 As New Point(120, 150)
        Dim P2 As New Point(220, 90)
        Dim P3 As New Point(330, 30)
        Dim P4 As New Point(410, 110)
        Dim sqrSize As New Size(6, 6)
        G.FillRectangle(Brushes.Black, New Rectangle(P1, sqrSize))
        G.FillRectangle(Brushes.Black, New Rectangle(P2, sqrSize))
        G.FillRectangle(Brushes.Red, New Rectangle(P3, sqrSize))
        G.FillRectangle(Brushes.Black, New Rectangle(P4, sqrSize))
        G.DrawBezier(Pens.Blue, P1, P2, P3, P4)
        P3 = New Point(330, 130)
        G.FillRectangle(Brushes.Red, New Rectangle(P3, sqrSize))
        G.DrawBezier(Pens.Blue, P1, P2, P3, P4)

        P3 = New Point(330, 230)
        G.FillRectangle(Brushes.Red, New Rectangle(P3, sqrSize))
        G.DrawBezier(Pens.Blue, P1, P2, P3, P4)

        P3 = New Point(330, 330)
        G.FillRectangle(Brushes.Red, New Rectangle(P3, sqrSize))
        G.DrawBezier(Pens.Blue, P1, P2, P3, P4)
    End Sub

    Function GetGraphicsObject() As Graphics
        Dim bmp As Bitmap
        bmp = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        PictureBox1.Image = bmp
        Dim G As Graphics
        G = Graphics.FromImage(bmp)
        Return G
    End Function

End Class
